#include "opencv2/opencv.hpp"

int main()
{
    cv::namedWindow("input", cv::WINDOW_AUTOSIZE);
    cv::namedWindow("output", cv::WINDOW_AUTOSIZE);
    cv::VideoCapture cap(0);
    cv::Mat input;
    cap >> input;
    cv::Mat output(input.rows, input.cols, CV_8UC3);

    while (1) {
        cap >> input;

        for (int j = 0; j < input.rows; j++) {
            for (int i = 0; i < input.cols; i++) {
                cv::Vec3b pixel = input.at<cv::Vec3b>(j, i);
                uchar blue  = pixel[0];
                uchar green = pixel[1];
                uchar red   = pixel[2];

                if (red > 150 && green <100 && blue <100) {
                    output.at<cv::Vec3b>(j, i)[0] = 0;
                    output.at<cv::Vec3b>(j, i)[1] = 0;
                    output.at<cv::Vec3b>(j, i)[2] = 255;
                } else {
                    output.at<cv::Vec3b>(j, i)[0] = 0;
                    output.at<cv::Vec3b>(j, i)[1] = 0;
                    output.at<cv::Vec3b>(j, i)[2] = 0;
                }
            }
        }

        cv::imshow("input", input);
        cv::imshow("output", output);
        if (cv::waitKey(30) > 0) {
            break;
        }
    }
}
