#include "opencv2/opencv.hpp"

int main()
{
    cv::namedWindow("input", cv::WINDOW_AUTOSIZE);
    cv::namedWindow("output", cv::WINDOW_AUTOSIZE);

    cv::VideoCapture cap(0);
    cv::Mat input_orig, input, output;

    cv::namedWindow("control", cv::WINDOW_AUTOSIZE);
    cv::Mat control(1, 400, CV_8U);

    // int c0min = 0, c0max = 25,
    //    c1min = 50, c1max = 210, 
    //    c2min = 95, c2max = 255;

    int c0min = 0, c0max = 100, 
        c1min = 0, c1max = 100, 
        c2min = 150, c2max = 255;

    cv::createTrackbar("C0 min", "control", &c0min, 255);
    cv::createTrackbar("C0 max", "control", &c0max, 255);
    cv::createTrackbar("C1 min", "control", &c1min, 255);
    cv::createTrackbar("C1 max", "control", &c1max, 255);
    cv::createTrackbar("C2 min", "control", &c2min, 255);
    cv::createTrackbar("C2 max", "control", &c2max, 255);

    while (1) {
        cap >> input;
        input.copyTo(input_orig);

//        cv::cvtColor(input, input, CV_BGR2HSV);
        cv::inRange(input,
                    cv::Scalar(c0min, c1min, c2min),
                    cv::Scalar(c0max, c1max, c2max), output);

        cv::imshow("input", input_orig);
        cv::imshow("output", output);
        cv::imshow("control", control);
        if (cv::waitKey(30) > 0) {
            break;
        }
    }
}
