#include "opencv2/opencv.hpp"

int main()
{
    cv::namedWindow("input", cv::WINDOW_AUTOSIZE);
    cv::namedWindow("output", cv::WINDOW_AUTOSIZE);

    cv::VideoCapture cap(0);
    cv::Mat input, prev_frame, output;
    cap >> input;
    cv::Mat diff(input.rows, input.cols, CV_16S);
    cv::cvtColor(input, prev_frame, CV_BGR2GRAY);

    while (1) {
        cap >> input;
        cv::cvtColor(input, input, CV_BGR2GRAY);
        
        for (int j = 0; j < input.rows; j++) {
            for (int i = 0; i < input.cols; i++) {
                diff.at<short>(j, i)
                    = input.at<uchar>(j, i) - prev_frame.at<uchar>(j, i);
            }
        }

        // /* Or, using a OpenCV function: */
        // cv::subtract(input, prev_frame, diff, cv::Mat(), CV_16S);

        prev_frame = input;
        diff.convertTo(output, CV_8U, 0.5, 128); // 0.5 * value + 128

        cv::imshow("input", input);
        cv::imshow("output", output);
        if (cv::waitKey(30) > 0) {
            break;
        }
    }
}
