#include "opencv2/opencv.hpp"

int main()
{
    cv::namedWindow("input", cv::WINDOW_AUTOSIZE);
    cv::namedWindow("output", cv::WINDOW_AUTOSIZE);

    cv::VideoCapture cap(0);
    cv::Mat input, output;

    int thresh = 150;
    cv::createTrackbar("threshold", "input", &thresh, 255);

    while (1) {
        cap >> input;
        cv::cvtColor(input, input, CV_BGR2GRAY);
        cv::threshold(input, input, thresh, 255, cv::THRESH_BINARY);

        cv::erode(input, output, cv::Mat(), cv::Point(-1, -1), 3);
        cv::dilate(output, output, cv::Mat(), cv::Point(-1, -1), 3);
        
        cv::imshow("input", input);
        cv::imshow("output", output);
        if (cv::waitKey(30) > 0) {
            break;
        }
    }
}
